<?php
// Copyright 2013 borowicz.info nightly dev preview
// This file is part of esoTalk/plugin abShoutBOX. Please see the included license file for usage information.

if(!defined('IN_ESOTALK')) exit;

ET::$pluginInfo['abShoutBox'] = array(
	'name' => 'abShoutBox',
	'description' => 'some simple chat based on jquery.',
	'version' => '0.11dev',
	'author' => 'borowicz.info',
	'authorEmail' => 'esotalk-plugins@borowicz.info',
	'authorURL' => 'http://borowicz.info',
	'license' => 'GPLv2'
);


class ETPlugin_abShoutBox extends ETPlugin {
	
	var $c			= array(); //config
	var $sb			= array(); //sb
	var $url 		= '';	   //site url
	var $notBanned	= true;	   //flag 
	var $isLogged	= false;   //flag 

	public function handler_init($sender) 
	{
		
		$this->conf();
		$this->url = 'conversation/sb.json&userId='.ET::$session->userId.'&token='.ET::$session->token;
		$sender->addToMenu('meta', 'shoutBox', '<a href="#">'.T('shoutBox').'</a>');
		$sender->addJSFile($this->getResource("sb.js"));
		$sender->addCSSFile($this->getResource("sb.css"));
		$sender->addCSSFile($this->getResource("../../BBCode/resources/bbcode.css"));
		$sender->addCSSFile($this->getResource("../../EmoticonsPlus/resources/emoticon.css"));
	}

	
	public function conf()
	{
		if ( ET::$session->userId && ET::$session->token )
		{
			$this->isLogged = true;
		}
		
		$this->c = array();
		
		$this->c['lastEntry'] = 0;
		if ( isset($_REQUEST['l']) && (int)$_REQUEST['l']>0 ) $this->c['lastEntry'] = (int)$_REQUEST['l'];
		
		$this->c['refresh'] = C('plugin.abShoutBox.refresh');
		if ( (int)$this->c['refresh'] < 2001 ) $this->c['banlenght'] = 2000;
		
		$this->c['enabled'] = C('plugin.abShoutBox.enabled');
		if ( (int)$this->c['enabled'] == 0 ) $this->c['enabled'] = 0;
		
		$this->c['position'] = C('plugin.abShoutBox.position');
		if ( (int)$this->c['moderation'] < 2 ) $this->c['moderation'] = 1;
		
		$this->c['title'] = C('plugin.abShoutBox.title');
		if ( empty($this->c['title']) ) $this->c['title'] = T('ShoutBOX');
		
		$this->c['entries'] = C('plugin.abShoutBox.entries');
		if ( (int)$this->c['entries'] == 0 ) $this->c['entries'] = 20;
		if ( (int)$this->c['entries'] < 10 ) $this->c['entries'] = 10;
		if ( (int)$this->c['entries'] > 50 ) $this->c['entries'] = 50;
		
		$this->c['archive'] = C('plugin.abShoutBox.archive');
		if ( (int)$this->c['archive'] == 0 ) $this->c['archive'] = 0;
		
		$this->c['moderation'] = C('plugin.abShoutBox.moderation');
		if ( (int)$this->c['moderation'] < 2 ) $this->c['moderation'] = 1;
		
		$this->c['ban'] = C('plugin.abShoutBox.ban');
		if ( (int)$this->c['ban'] < 2 ) $this->c['ban'] = 1;
		
		$this->c['banlenght'] = C('plugin.abShoutBox.banlenght');
		if ( (int)$this->c['banlenght'] == 0 ) $this->c['banlenght'] = 0;
		
		$this->c['banned'] = '';//@todo
		$this->c['banned'] = C('plugin.abShoutBox.banned');
		$this->c['banned'] = str_replace(';', ',', $this->c['banned']);
		if ( stristr(C('plugin.abShoutBox.banned'),',') ) 
		{
			$this->c['banned'] = explode('',$this->c['banned']);
		}
		
		if ( count($this->c['banned'])<1 ) 
		{
			$this->c['banned'] = array();
		}
	}
	
	public function handler_conversationController_renderBefore($sender)
	{

	}
	
	public function handler_pageEnd($sender) 
	{
		if (ET::$controllerName == C("esoTalk.defaultRoute") and ET::$controller->controllerMethod == 'index')
		{
			switch ($this->c['enabled']) //@todo check login
			{
				case 2:
					if( $this->isLogged && $this->sb_notBanned() ) 
					{
						echo $this->sb_Box($sender);
					}
					break;
				case 1:
					echo $this->sb_Box($sender);
					break;
				case 0:
				default:
					return;
					break;
			}


		}
	}
	
	/**
	 * ad soutBox to the conversation view
	 * @todo if settings visible only
	 */
	public function conversationController_sb($sender)
	{
		$sender->responseType = RESPONSE_TYPE_JSON;
		switch ($this->c['enabled'])
		{
			case 2:
			case 1:
				if( isset($_REQUEST['m']) ) 
				{
					if( $this->sb_notBanned() && $sender->validateToken() && $this->isLogged )
					{
						$this->sb_sendShout(); //send shout
					}
				}
				else {
					$this->sb_loadData(); //load shouts
				}
				$sender->json("sb", $this->sb);
				
				break;
			case 0:
			default:
				return;
				break;
		}
		$sender->render();
	}
	
	private function sb_Box($sender)
	{
		return '
<script>

	var lastEntry = 0;
	var siteUrl = "'.URL().'";
	var sbUrl = "'.$this->url.'";
	function sbRefresh()
	{
		setTimeout(sbRefresh,'.$this->c['refresh'].');
		sbReload(true);
	}
	if( $(document).ready() )
	{
		sbReload(true);
		$(function() {
			sbRefresh();
		});
	}
</script>
			<div id="shoutBox" class="sb-content">
				<div id="shoutBoxTitle">'.$this->c['title'].'</div>
				
<div id="shoutBoxMessages" class="sb-msg">

</div>
			'.$this->sb_msgBox().'
			</div>
			';
	}
	
	/**
	 * add sb msg field
	 * @todo check if banned and logged
	 */
	private function sb_msgBox($sender) 
	{
		if( $this->isLogged && $this->sb_notBanned() ) 
		{
		return '
					<input name="sbm" type="text" id="sbm" onKeyPress="sbSendSubmit(event)" style="float: left;" />
<a href="#" onClick="sbReload(true)" >reload</a>
<span class="sb-loading"></span>
					<input type="button" name="submitsmg" id="submitmsg" onClick="sbSend()" value="'.T('Send').'" />
				';
				//</form>';
		
		} else {
			//@todo banned / not logged
		}
	}
	
	/**
	 * Setting form on admin panel
	 * @todo
	 * init table via button
	 */
	public function sb_sendShout()
	{
		$shout = '';
		$shout = sanitizeHTML($_REQUEST['m']);

		ET::SQL()->insert("shoutbox")
			->set("memeberIp", $_SERVER['REMOTE_ADDR'])
			->set("memeberId", ET::$session->userId)
			->set("memeberName", ET::$session->user['username'])
			->set("shoutMessage", $shout)
			->exec();	
	}	
	
	/**
	 * Setting form on admin panel
	 * @todo
	 * init table via button
	 */
	public function sb_loadData()
	{

		if ( $this->c['lastEntry']>0 ) {
			$result = ET::SQL()
				->select('idShout, shoutTime, memeberId, memeberName, shoutMessage')
				->from('shoutbox')
				//->where('idShout > '.$this->c['lastEntry']) //@todo
				->orderBy('idShout DESC')
				->limit('0,'.$this->c['entries'])
				->exec();
		}
		else {
			$result = ET::SQL()
				->select('idShout, shoutTime, memeberId, memeberName, shoutMessage')
				->from('shoutbox')
				->orderBy('idShout DESC')
				->limit('0,'.$this->c['entries'])
				->exec();
		}
		
		//memberURL
		$cnt = $this->c['entries'];
		$this->sb['lastEntry'] = 0;
		while($row = $result->nextRow()) {
			if ($this->sb['lastEntry']==0) $this->sb['lastEntry'] = $row['idShout'];
			$this->sb['shouts'][$cnt] = array(
				'idShout' => $row['idShout'],
				'shoutTime' => $this->sb_timeShout($row['shoutTime']),
				'memeberId' => $row['memeberId'],
				'memeberName' => $row['memeberName'],
				'shoutMessage' => $this->sb_parseShout($row['shoutMessage']),
			);
			$cnt--;
		}
		
		ksort($this->sb['shouts']); //sort array by key for js

	}

	/**
	 * check if user is not banned
	 * @todo
	 * init table via button
	 */
	public function sb_notBanned() //@todo
	{
		if ( in_array(ET::$session->userId, $this->c['banned']) )
		{
			$this->notBanned = false;
			return false;
		}
		else {
			$this->notBanned = true;
			return true;
		}
	}
	
	/**
	 * load bans
	 * @todo many more
	 */
	public function sb_loadBan() 
	{
	
	}
	
	/**
	 * Setting form on admin panel
	 * @todo
	 * init table via button
	 */
	public function sb_tableInit() 
	{
		$sql = 'CREATE TABLE IF NOT EXISTS '.ET::$database->tablePrefix.'shoutbox 
				(
idShout mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
shoutTime timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
memeberId mediumint(8) unsigned NOT NULL DEFAULT "0",
memeberIp varchar(12) COLLATE utf8_unicode_ci DEFAULT NULL,
color varchar(7) COLLATE utf8_unicode_ci NOT NULL,
memeberName tinytext COLLATE utf8_unicode_ci NOT NULL,
shoutMessage text COLLATE utf8_unicode_ci NOT NULL, 
PRIMARY KEY(idShout)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1';
		ET::SQL($sql);

		//upgrade 
		//$sql = 'ALTER TABLE '.ET::$database->tablePrefix.'shoutbox ADD color VARCHAR(7) NOT NULL AFTER memeberId';
		//ET::SQL($sql);
		
		
		$sql = 'INSERT IGNORE '.ET::$database->tablePrefix.'shoutbox(idShout, shoutTime, memeberId, memeberIp, color, memeberName, shoutMessage) VALUES("", NOW(), 1, "127.0.0.1", "#800000", "shoutBox deamon", "[b]welcome on simple shout box by http://borowicz.info/esotalk[/b]");';
		ET::SQL($sql);
		

	}

	/**
	 * Setting form on admin panel
	 * @todo parse today/yesterday etc
	 */
	public function sb_timeShout($dateTime)
	{
		$day = date("Y-m-d", strtotime($dateTime));
		$today = date("Y-m-d");
		if($day == $today) 
		{
			$dateTime = date("H:i", strtotime($dateTime));
		} 
		else {
			$dateTime = date("Y-m-d H:i", strtotime($dateTime));
		}
		return $dateTime;
	}

	/**
	 * Setting form on admin panel
	 * @todo
	 * init table via button
	 */
	public function sb_parseShout($shout) //@todo
	{
		$shout = $this->sb_parseLink($shout);
		$shout = $this->sb_parseBBCode($shout);
		return $shout;
	}
	
	public function sb_parseBBCode($text) //@todo
	{
		//b
		$text = preg_replace("/\[b\](.*)\[\/b\]/sUi", "<b>$1</b>", $text);

		//i
		$text = preg_replace("/\[i\](.*)\[\/i\]/sUi", "<i>$1</i>", $text);

		//u - underline
		$text = preg_replace("/\[u\](.*)\[\/u\]/sUi", "<u>$1</u>", $text);

		return $text;
	}
	
	public function sb_parseLink($text) //@todo
	{

        // The Regular Expression filter
        $reg_exUrl = "/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,4}(\/\S*)?/";

		// Check if there is a url in the text
		if(preg_match_all($reg_exUrl, $text, $url)) 
		{
			// make the urls hyper links
			$matches = array_unique($url[0]);
			foreach($matches as $match) 
			{
				$replacement = '<a href='.$match.' target="_blank">';
				strlen($match)<30 ? $replacement.= $match : $replacement.= substr($match,0,25).' ... '.substr($match,-5);
				$replacement.= '</a>';
				$text = str_replace($match,$replacement,$text);
			}
		}
		return nl2br($text);
	}
	
	/**
	 * Setting form on admin panel
	 * @todo
	 * init table via button
	 */
	public function sb_timeFormat($time) //@todo
	{
		//today
		//yesterday
		//last week
	}
	
	/**
	 * Setting form on admin panel
	 * @todo
	 * init table via button
	 */
	 
	public function settings($sender)
	{
		$this->sb_tableInit(); //create Tables
		
		$form = ETFactory::make('form');
		$form->action = URL('admin/plugins');
		
		$form->setValue('enabled', 		$this->c['enabled']);
		$form->setValue('position', 	$this->c['position']);
		$form->setValue('title', 		$this->c['title']);
		$form->setValue('refresh', 		$this->c['refresh']);
		$form->setValue('entries', 		$this->c['entries']);
		$form->setValue('archive', 		$this->c['archive']);
		$form->setValue('moderation',	$this->c['moderation']);
		$form->setValue('ban', 			$this->c['ban']);
		$form->setValue('banlenght', 	$this->c['banlenght']);
		$form->setValue('banned', 		$this->c['banned']);
		
		if ($form->validPostBack("abShoutBoxSave")) 
		{
			$config = array();
			$config['plugin.abShoutBox.enabled'] 	= $form->getValue('enabled');
			$config['plugin.abShoutBox.position'] 	= $form->getValue('position');
			$config['plugin.abShoutBox.title'] 		= $form->getValue('title');
			$config['plugin.abShoutBox.refresh'] 	= $form->getValue('refresh');
			$config['plugin.abShoutBox.entries'] 	= $form->getValue('entries');
			$config['plugin.abShoutBox.archive'] 	= $form->getValue('archive');
			$config['plugin.abShoutBox.moderation'] = $form->getValue('moderation');
			$config['plugin.abShoutBox.ban'] 		= $form->getValue('ban');
			$config['plugin.abShoutBox.banlenght'] 	= $form->getValue('banlenght');
			$config['plugin.abShoutBox.banned'] 	= $form->getValue('banned');
			
			if (!$form->errorCount()) // if no errors save config.
			{
				ET::writeConfig($config);
				$sender->message(T("message.changesSaved"), "success");
				$sender->redirect(URL("admin/plugins"));
			}
		}
		
		$sender->data("abShoutBoxSettingsForm", $form);
		return $this->getView("settings");
	}

}

?>